import entities.Bubble;
import entities.Ripple;
import entities.Title;

import flash.display.InteractiveObject;

import com.haxepunk.Scene;
import com.haxepunk.Entity;
import com.haxepunk.HXP;
import com.haxepunk.graphics.Image;
import com.haxepunk.utils.Input;

import com.haxepunk.graphics.Text;

import com.haxepunk.Sfx;


class MainScene extends Scene {
	//counting levels
	var stageNumber:Int = 0;
	//var bubbleCounter:Int = 0;
	
	//array of bubbles
	var bubbles:Array<Bubble> = new Array<Bubble>();
	//var bubblesToRemove:Array<Int> = new Array<Int>();
	
	//for background
	var startingColor:Int = 0x66CCFF;
	
	//sfx
	var stageChange:Sfx;
	var music:Sfx;
	
	var gameLost:Bool = false;
	
	//texts
	var title:Title;
	var credits:Text;
	
	public function new() {
		super();
		
		stageChange = new Sfx("audio/stagechange.mp3");
		music = new Sfx("audio/ripples.mp3");
		
	}
	 
	public override function begin() {
        //block = addGraphic(new Image("graphics/player.png"));
	   
		HXP.screen.color = startingColor;
		
		title = new Title(cast(HXP.screen.width / 2 - 50, Int), cast(HXP.screen.height / 2 - 50, Int));
		add(new Title());
	   
		spawnBubble(cast(HXP.screen.width / 2, Int), cast(HXP.screen.height / 2, Int), true);
		
		//music.play(0.02);
		//music.volume = 0.1;
		
    }

    public override function update() {
		
		
        super.update();
		
		//when clicked, check if all bubbles are currently hit
		if (Input.mousePressed) {
			var allHit:Bool = true;

			//check for bubbles hit
			for (i in 0...bubbles.length) {
				
				//trace(bubbles[i].markedHit);
				if (bubbles[i].markedHit == false) {
					allHit = false;
				}
			}
			
			if (allHit == true) {
				nextStage();
			}
			
			// spawn ripple
			if (!gameLost) {
				spawnRipple(Input.mouseX, Input.mouseY);
			}
			
			title.active = false;
			
		}
		
		for (i in 0...bubbles.length) {
			var n:Int = bubbles.length - i -1;
			if (bubbles[n].markedDead == true) {
				bubbles[n].markedDead == false;
				
				// lost the game
				gameLost = true;
				
				// THERE IS A BUG HERE
				bubbles.splice(n, 1);
			
				previousStage();
				break;
			}
		}
		
		if (gameLost) {
			
			for (i in 0...bubbles.length) {
				bubbles[i].gameLost = true;
				
			}
			
			music.stop();
		}
		
		//for (i in bubblesToRemove.length...0) {
			
		//}

    }

    //private var block:Entity;
	
	public function spawnRandomBubble() {
		//spawn a bubble at random location
		//prevent overlapping bubbles
		var isOverlapping:Bool = true;
		
		var randomX:Int = 0;
		var randomY:Int = 0;
		while (isOverlapping) {
			
			randomX = cast(Math.random() * (HXP.screen.width - 100) +50, Int);
			randomY = cast(Math.random() * (HXP.screen.height - 100) +50, Int);
			
			//check overlap
			if (false) {
				
				randomX = cast(Math.random() * HXP.screen.width, Int);
				
			}
			isOverlapping = false;
		}
		spawnBubble(randomX, randomY);
	}
	
	public function spawnBubble(x:Int, y:Int, ?firstBubble:Bool = false) {
		var newBubble:Bubble = new Bubble(x, y, firstBubble);
		bubbles.push(newBubble);
		add(newBubble);
	}
	
	public function spawnRipple(x:Int, y:Int) {
		var tempRipple:Ripple = new Ripple(x, y);
		add(tempRipple);
	}
	
	
	// stages determine the background color and the difficulty
	public function nextStage() {
		if (true) {
			stageNumber++;
			changeBackgroundColor(stageNumber);
			stageChange.play();
			
			if (stageNumber == 1) {
				music.loop();
				gameLost = false;
			}
		}
		
			spawnRandomBubble();
	}
	
	public function previousStage() {
		if (stageNumber > 0) {
			stageNumber--;
			changeBackgroundColor(stageNumber);
		}
	}
	
	public function changeBackgroundColor(x:Int) {
		//darken the screen at each stage
		var tempColor:Int = startingColor;
		
		for (i in 0...x) {
			
			var x:Int = (0xE)  * 0x10000;
			var y:Int = (0xB)  * 0x100;
			var z:Int = (0x8)  * 0x1;
			
			if ((tempColor / 0x10000) > (x / 0x10000) * 0x2) {
				tempColor -= x;
			}
			
			if (((tempColor % 0x10000) / 0x100) > (y / 0x100) * 0x3) {
				tempColor -= y;
			}
			
			if (((tempColor  % 0x100) / 0x1) > z * 0x5) {
				tempColor -= z;
			}
			
		}
		HXP.screen.color = tempColor;
	}
	  
 }