package entities;

import com.haxepunk.HXP;
import com.haxepunk.Entity;
import com.haxepunk.graphics.Image;
import com.haxepunk.graphics.Spritemap;
import com.haxepunk.utils.Input;
import com.haxepunk.utils.Key;
import com.haxepunk.Sfx;

import haxe.Timer;

/**
 * ...
 * @author Andrew Shuan Dang
 */
class Bubble extends Entity
{
	private var sprite:Spritemap;
	
	//var hitDuration:Int = 1000;
	//var hitTimer:Timer;
	
	//var explosionDuration:Int = 1000;
	//var explosionTimer:Timer;
	
	public var markedHit:Bool = false;
	public var markedDead:Bool = false;
	public var isFirstBubble:Bool = false;
	public var persistent:Bool = false;
	
	public var gameLost:Bool = false;
	
	//sfx
	var hit:Sfx;
	var surfaced:Sfx;
	var stageChange:Sfx;
	var explosion:Sfx;

	public function new(x:Int, y:Int, ?firstBubble:Bool=false)
	{
		super(x, y);
		
		isFirstBubble = firstBubble;
		if (firstBubble) {
			persistent = true;
		}
		
		//sfx
		hit = new Sfx("audio/hit.mp3");
		surfaced = new Sfx("audio/surfaced.mp3");
		stageChange = new Sfx("audio/stagechange.mp3");
		explosion = new Sfx("audio/explosion.mp3");
		
		//animated sprite
		sprite = new Spritemap("graphics/bubble.png", 96, 96);
		
        sprite.add("submerged", [0, 1, 2, 3, 4, 5, 6, 7, 8, 9], 2, false);
        sprite.add("surfaced", [10, 11, 12, 13, 14], 4, false);
		sprite.add("idle", [13, 14], 2);
		sprite.add("danger", [15, 16, 17, 18, 19, 20, 
								21, 22, 23], 12, false);
		sprite.add("explosion", [29, 25, 26, 27, 28, 29], 8, false);
		sprite.add("empty", [29], 1, false);
		
        sprite.play("submerged");
		
		graphic = sprite;
		graphic.x = -45;
		graphic.y = -45;
	}
	
	public override function update()
	{	
		if (sprite.currentAnim == "submerged") {
			if (sprite.complete) {
				sprite.play("surfaced");
				markedHit = false;
				surfaced.play();
			}
		}
		
		if (Input.mousePressed) {
			if (sprite.currentAnim == "surfaced" || 
				sprite.currentAnim == "danger" ||
				sprite.currentAnim == "idle" ){
				if (Input.mouseX > this.x - 45 && Input.mouseX < this.x + 45 &&
					Input.mouseY > this.y - 45 && Input.mouseY < this.y + 45 ) {
					if (!gameLost || persistent) {
						markedHit = true;	
						activateHit();
						hit.play();
						
						if (persistent) {
						persistent = false;
					}
					}
					
					
					
				}
			}
		}
			
		if (sprite.currentAnim == "surfaced"){
			
			if (sprite.complete) {
				if (!persistent) {
					sprite.play("danger");
				} else {
					sprite.play("idle");
				}
			}
			
		}
		
		if (sprite.currentAnim == "danger") {
			if (sprite.complete) {
				sprite.play("explosion");
				explosion.play();
			}
		}
		
		if (sprite.currentAnim == "explosion") {
			
			markedDead = true;
			if (sprite.complete) {
				sprite.play("empty");
			}
		}
		
		if (sprite.currentAnim == "empty" && sprite.complete) {
			if (markedDead = false) {
				HXP.world.remove(this);
			}
		}
		
		//trace(HXP._systemTime);
		//check Hit Timer
		
		super.update();
		
		
	}
	
	public function activateHit() {
		
		//reset animations
		sprite.play("submerged");
		
		//reset timer
		//resetHitTimer();
		
		//
		
	}
	
	public function resetHitTimer() {
		//hitTimer.stop();
		//hitTimer = new Timer(hitDuration);
		//hitTimer.run = resetHit;
		
	}
	
	public function resetHit():Void {
		//markedHit = false;
		
	}
}